/* bumbleshow0.c -- black & white bumbleball!
 *
 * BGG
*/

#include <Xm/Xm.h>
#include <Xm/BulletinB.h>
#include <Xm/DrawingA.h>

#include <stdio.h>

#include "/musr/cmix/H/RTsockfuncs.h"
#include "/musr/cmix/H/randfuncs.h"

int theSock;
int RTpid;

float pitches1[4] = { 8.00, 8.02, 8.05, 8.07 };
	float pitches2[4] = { 6.00, 6.01, 6.02, 6.03 };
	float pitches3[4] = { 9.04, 9.07, 9.11, 9.05 };
	float pitches4[4] = { 7.09, 8.09, 9.09, 6.09 };

Widget theDraw, topLevel, bboard;
int xball,yball;

GC gc;

XtAppContext app;


main(argc,argv)
int argc;
char *argv[];
{
	void gobumble();

	/* start up the instrument */
	RTpid = RTopensocket(0, "CMIX");
	sleep(3); /* allow the process time to start */

	/* open up the socket */
	theSock = RTsock("localhost", 0);

	/* set up the instrument */
	RTsendsock("rtsetparams", theSock, 3, 22050.0, 1.0, 256.0);
	RTsendsock("load", theSock, 1, "STRUM");


	/* now do the window stuff */
	topLevel=XtVaAppInitialize(&app,"Bumbleshow",
		NULL,0,&argc,argv,NULL,NULL);

	/* set up the main window */
	bboard = XtVaCreateManagedWidget("bboard",
		xmBulletinBoardWidgetClass, topLevel,
		XmNwidth, 500, XmNheight, 500, 
		XmNmarginWidth, 0, XmNmarginHeight, 0,NULL);

	/* set up the "graphics context */
	gc = XCreateGC(XtDisplay(bboard),
		RootWindowOfScreen(XtScreen(bboard)), 0, NULL);

	/* set up the drawing area in the main window */
	theDraw = XtVaCreateManagedWidget("theDraw",
		xmDrawingAreaWidgetClass, bboard,
		XmNwidth, 500, XmNheight, 500,
		XmNbackground, WhitePixelOfScreen(XtScreen(bboard)), NULL);

	tsrand(); /* seeds the random stuff by time-of-day */

	xball = brrand() * 500.0;
	yball = brrand() * 500.0;

	XtManageChild(bboard);
	XtManageChild(theDraw);
	XtRealizeWidget(topLevel);

	/* get the timer going */
	RTtimeit(0.2, gobumble);

	XtAppMainLoop(app);
}


void gobumble()
{
	int index;
	float note;

	/* erase the ball */
	XSetForeground(XtDisplay(theDraw), gc, WhitePixelOfScreen(XtScreen(bboard)));
	XFillArc(XtDisplay(theDraw), XtWindow(theDraw), gc, xball, yball,
		10, 10, 0, (360*64));

	xball = (int)(rrand()*50.0) + xball;
	yball = (int)(rrand()*50.0) + yball;
	if (xball > 500) xball = 490;
	if (xball < 0) xball = 10;
	if (yball > 500) yball = 490;
	if (yball < 0) yball =  10;

	/* redraw the axes */
	XSetForeground(XtDisplay(theDraw), gc, BlackPixelOfScreen(XtScreen(bboard)));
	XDrawLine(XtDisplay(theDraw), XtWindow(theDraw), gc, 250, 0, 250, 500);
	XDrawLine(XtDisplay(theDraw), XtWindow(theDraw), gc, 0, 250, 500, 250);

	/* redraw the ball */
	XSetForeground(XtDisplay(theDraw), gc, BlackPixelOfScreen(XtScreen(bboard)));
	XFillArc(XtDisplay(theDraw), XtWindow(theDraw), gc, xball, yball,
		10, 10, 0, (360*64));

	XFlush(XtDisplay(theDraw));

	/* ok, decide where the ball is */
	if (xball < 250) { 
		if (yball < 250) {
			index = brrand() * 4.0;
			note = pitches1[index];
		}
		else {
			index = brrand() * 4.0;
			note = pitches2[index];
		}
	}
	else {
		if (yball < 250) {
			index = brrand() * 4.0;
			note = pitches3[index];
		}
		else {
			index = brrand() * 4.0;
			note = pitches4[index];
		}
	}

/* p0 = start; p1 = dur; p2 = pitch (oct.pc); p3 = fundamental decay time
   p4 = nyquist decay time; p5 = amp, p6 = squish; p7 = stereo spread [optional]
*/
		RTsendsock("START", theSock, 7, 0.0, 1.0, note, 1.0, 0.5, 5000.0, 1.0);
}

